/*
    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) <year>  <name of author>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/

#include "hebevm.h"

#include <QDebug>

HebeVM::HebeVM()
{
	mpProc = 0;
	mpCons = 0;
	mpPage = 0;
	mIPLed = false;
	mStarted = false;
	mScpMsgPrfx = false;
	mNumCPUs = 1;
	mTermIssued = false;
}

bool HebeVM::operator== ( const HebeVM &other ) const
{
	return (this->mName == other.mName);
}


HebeVmList::HebeVmList()
{
}

HebeVmList::~HebeVmList()
{
}

int HebeVmList::activeImages()
{
	int active = 0;
	for ( int k = 0; k < mVMs.count(); ++k )
		if ( mVMs[k].mStarted ) ++active;
		
	return active;
}

void HebeVmList::addVM( const HebeVM &vm )
{
	mVMs << vm;
	mVMnames << vm.mCnfFile;
}

void HebeVmList::addObjMap( KProcess *obj, HebeVM *vm )
{
	mMapObject[reinterpret_cast<QObject *>( obj )] = vm;
}

void HebeVmList::addObjMap( QTimer *obj, HebeVM *vm )
{
	mMapObject[reinterpret_cast<QObject *>( obj )] = vm;
}

int HebeVmList::count() const
{
	return mVMs.count();
}

HebeVM* HebeVmList::objMap( QObject *pSender )
{
	return mMapObject[pSender];
}

void HebeVmList::removeVM( const HebeVM &vm )
{
	mVMnames.removeOne( vm.mCnfFile );
	mVMs.removeOne( vm );
}

void HebeVmList::removeObjMap( KProcess *obj )
{
	mMapObject.remove( reinterpret_cast<QObject *>( obj ) );
}

void HebeVmList::removeObjMap( QTimer *obj )
{
	mMapObject.remove( reinterpret_cast<QObject *>( obj ) );
}

HebeVM* HebeVmList::VM( const int k )
{
	if ( (k > -1) & (k < mVMs.count()) )
		return &mVMs[k];
	else
		return 0;
}

QStringList HebeVmList::VMnames() const
{
	return mVMnames;
}

