/*
    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) <year>  <name of author>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/

#ifndef HEBEVM_H
#define HEBEVM_H

#include <qtimer.h>
#include <kprocess.h>
#include <KPageWidgetItem>
#include <KPageWidget>
#include <hebecons.h>
#include <hebeview.h>
#include <hebe.h>

class Hebe;

class HebeVM
{
public:
	HebeVM();
	bool operator== ( const HebeVM &other ) const;
	
	KProcess *mpProc;
	HebeCons *mpCons;
	KPageWidgetItem *mpPage;
	QTimer	 *mpTimer;
	QString  mName;
	QString  mCnfFile;
	QString  mDir;
	bool		 mIPLed;	
	bool		 mStarted;	
	bool		 mScpMsgPrfx;
	int			 mNumCPUs;	
	bool     mTermIssued;
};

class HebeVmList: public QObject
{
public:
	HebeVmList();
	virtual ~HebeVmList();
	
	int activeImages();
	HebeVM* VM( const int k );
	int count() const;
	void addVM( const HebeVM& vm );
	void addObjMap( KProcess*, HebeVM* );
	void addObjMap( QTimer*, HebeVM* );
	HebeVM* objMap( QObject* pSender );
	void removeVM( const HebeVM& vm );
	void removeObjMap( KProcess* );
	void removeObjMap( QTimer* );
	QStringList VMnames() const;

private:	
	QList<HebeVM> mVMs;
	QStringList mVMnames;
	QHash<QObject*, HebeVM*> mMapObject;
};

#endif // HEBEVM_H
