#include "hebe.h"
#include <kapplication.h>
#include <kaboutdata.h>
#include <kcmdlineargs.h>
#include <KDE/KLocale>

static const char description[] =
    I18N_NOOP("Hebe - Hercules Image Manager");

static const char version[] = "0.4";

int main(int argc, char **argv)
{
    KAboutData about("hebe", 0, ki18n("Hebe"), version, ki18n(description),
                     KAboutData::License_GPL, ki18n("(C) 2010 Robin Atwood"), KLocalizedString(), 0, "robin@binro.org");
    about.addAuthor( ki18n("Robin Atwood"), KLocalizedString(), "robin@binro.org" );
    KCmdLineArgs::init(argc, argv, &about);

    KCmdLineOptions options;
    KCmdLineArgs::addCmdLineOptions(options);
    KApplication app;

    Hebe *widget = new Hebe;

    // see if we are starting with session management
    if (app.isSessionRestored())
    {
        RESTORE(Hebe);
    }
    else
    {
        // no session.. just start up normally
        KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
        if (args->count() == 0)
        {
            //hebe *widget = new hebe;
            widget->show();
        }
        else
        {
            int i = 0;
            for (; i < args->count(); i++)
            {
                //hebe *widget = new hebe;
                widget->show();
            }
        }
        args->clear();
    }

    return app.exec();
}
